/*
	ProWesS, PROGS Windowing System
	PROforma, PROGS Font & Raster Manager

	PFconfig : utility program for ProWesS package
		allows easy configuration of PROforma

	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
	29.09.1996 started
	21.10.1996 added help item in fileselect window
*/

#include "PFConfig.h"

/* === Select Drivers to load in PROforma === */

static Error driverload(PWObject object, char *dir, PWObject menu)
{
	Global *g;
	Error err;
	char *item;
	char string[MAX_LINE];

	PWQuery(object,PW_OBJECT_AUXILIARY,&g);
	PWQuery(menu,PW_MENU_SELECTED_FIRST,&item);
	catch( LineAdd(g,dir,&g->dpath) );
	while (item)
	{
		STRFormatPutSafe(string,MAX_LINE,"D %s%s",dir,item);
		err=THINGCall(PF_THING_NAME,PF_THING_CNFG,1,string);
		if (err) return DisplayError(err);
		catch( LineAdd(g,item,&g->drivers) );
		PWQuery(menu,PW_MENU_SELECTED_NEXT,&item);
	}
	return ERR_OK;
}

Error DriverAdd(Global *g)
{
	Error err;
	PWObject win, outl;

	catch( PWCreate(NULL,&win,PW_TYPE_FILESELECT,
					PW_FILESELECT_TITLE_TEXT, "select drivers",
					PW_FILESELECT_ACTION, driverload,
					PW_FILESELECT_DIRECTORY, "$PWSDIR_pf_driv",
					PW_FILESELECT_EXTENSION, "_pfd",
					PW_FILESELECT_MULTIPLE,
					PW_OBJECT_AUXILIARY, g,
					NULL) );
	catch( PWQuery(win,PW_FILESELECT_OUTLINE,&outl) );
	catch( PWChange(outl,
					PW_OUTLINE_SLEEP,
					PW_OUTLINE_HELP,
					PW_OUTLINE_HELP_DIRECTORY, "$PWSDIR_doc_",
					PW_OUTLINE_HELP_FILE, "PFconfig_html",
					PW_OUTLINE_HELP_POSITION, "adriv",
					NULL) );
	catch( PWChange(win,PW_FILESELECT_ACTIVATE,NULL) );
	return PWRemove(win);
}
