/*
	ProWesS, PROGS Windowing System
	PROforma, PROGS Font & Raster Manager

	PFconfig : utility program for ProWesS package
		allows easy configuration of PROforma

	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
	22.10.1996 started
*/

#include "PFConfig.h"

/* === set PROforma memory options === */

static Error set(PWObject object)
{
	Global *g;
	int *value;
	char string[20];

	PWQuery(object,PW_OBJECT_AUXILIARY,&value);
	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	PWChange(object,PW_EDLINE_GET,20,string,NULL);

	g->changed=TRUE;
	return STRFormatGet(string,NULL,"%d",value);
}

static EdlineSet(PWObject win, char *label, char key, int *value)
{
	Error err;
	char string[20];

	STRFormatPut(string,"%d",*value);
	catch( PWCreate(win,NULL,PW_TYPE_LABEL,
					PW_LABEL_TEXT, label,
					PW_SCALE_FACTOR, 0,
					PW_POSITION_NEXT_ROW,
					NULL) );
	catch( PWCreate(win,NULL,PW_TYPE_EDLINE,
					PW_EDLINE_MAXLENGTH, MAX_UNITSTRING,
					PW_EDLINE_SET, string,
					PW_EDLINE_KEYPRESS, key,
					PW_EDLINE_ACTION_AFTER, set,
					PW_OBJECT_AUXILIARY, value,
					NULL) );
	return err;
}

Error Memory(Global *g)
{
	Error err;
	PWObject win;
	char line[MAX_LINE];

	catch( PWCreate(NULL,&win,PW_TYPE_OUTLINE,
					PW_OUTLINE_TITLE_TEXT, "PROforma memory options",
					PW_OUTLINE_QUIT,
					PW_OUTLINE_QUIT_KEYPRESS, 27,
					PW_OUTLINE_SLEEP,
					PW_OUTLINE_HELP,
					PW_OUTLINE_HELP_DIRECTORY, "$PWSDIR_doc_",
					PW_OUTLINE_HELP_FILE, "PFconfig_html",
					PW_OUTLINE_HELP_POSITION, "memor",
					PW_GLOBAL_AUXILIARY, g,
					PW_WINDOW_NOSCALE,
					NULL) );

	catch( EdlineSet(win,"Max/min memory for Gstate",'m',&g->memory) );
	catch( EdlineSet(win,"Size of fontcache",'a',&g->cachesize) );
	catch( EdlineSet(win,"Number of fonts in cache",'n',&g->cachecount) );
	catch( EdlineSet(win,"Colour cache size",'c',&g->colcache) );

	err=PWActivate(win);
	PWRemove(win);

	STRFormatPut(line,"C %d %d",g->cachesize,g->cachecount);
	THINGCall(PF_THING_NAME,PF_THING_CNFG,1,line);
	STRFormatPut(line,"c %d",g->colcache);
	THINGCall(PF_THING_NAME,PF_THING_CNFG,1,line);
	STRFormatPut(line,"M %d",g->memory);
	THINGCall(PF_THING_NAME,PF_THING_CNFG,1,line);


	return err;
}
