/*
	test program for PROGS SMS C library

	rconfig : runtime config program. This program accepts as first
		parameter, the name of the thing which should accept the config lines,
		which are given as the following parameter(s).

	written by Joachim Van der Auwera for PROGS
	(c) by PROGS, Professional & Graphical Software
	started 12 June 1996
*/

#include "sms.h"
#include "io.h"
#include "str.h"
#include "thing.h"
#include "ProWesS.h"	/* for PW_THING_CONFIG */

#define catch(X) if (err=(X)) return err; else

Error init(char *param)
{
	Error err;
	Channel out, in;
	char line[256];
	Size len;
	char **list, *name;
	int sent;

	/* get the command line parameters */
	STRBreak(param,&list);
	if (*list==NULL) return ERR_ISYN;

	if (STRSameCI(*list,"-path") && *++list) list++;
	name=*list++;

	for ( ; *list ; list++)
	{
		if (STRSameCI(*list,"-path"))
		{
			if (!*++list) return ERR_IPAR;
		}
		else 
			catch( THINGCall(name,PW_THING_CNFG,1,*list) );
	}
	return ERR_OK;
}
